/* ========================================================================== *
 *  Generic-16 Multi Task Kernel                                              *
 *  Sample program for Generic-16 API sample                                  *
 * ========================================================================== */

#include        <stdio.h>
#include        "gen16.h"
#include        "test01.h"

    int proc01_pid ;
    int proc02_pid ;

/*****************************************************************************
 * main : C[`                                                     *
 * TvvÕX^[g|Cg                                      *
 *****************************************************************************/

int main(int nargc, char *pargv[] )
{
    int     nidx, npid ;
    int     nstchk ;
	char   *p ;

/* -------------------------------------------------------------------- *
   
 * -------------------------------------------------------------------- */

    printf( "Generic Multi task kernel sample program No.001\n" ) ;

/* -------------------------------------------------------------------- *
   Generic-16 J[l풓胋[`
   J[l풓̏ꍇ풓čēx`FbNBRNɎs
   ꍇ́AG[bZ[W\ĈُIB܂AɃJ[l
   풓Ăꍇ̓tO(nstchk)ݒ肵Č듮hB
 * -------------------------------------------------------------------- */

    nstchk = FALSE ;

    for ( nidx=0; nidx<RETRY_MAX; nidx++ )
    {
        if ( _checkstay() )
        {   
            printf( "Generic-16 J[l풓܂\n" ) ;
            printf( "Kernel = %s\n", GEN16_KERNEL ) ;
            system( GEN16_KERNEL ) ;
            nstchk = TRUE ;
        } else {
            printf( "Generic-16 J[l̏풓mF܂\n" ) ;
        	break ;
        }
    }
    if ( nidx == RETRY_MAX )
    {
        printf( "Generic-16 J[l풓ł܂ł\n" ) ;
        printf( "fBNg\`FbNċNȂĂ\n" ) ;
        exit(0);
    }

/* -------------------------------------------------------------------- *
   vZXo^[`
   vZX̃X^bN̈抄蓖ẮAK alloca֐gpĂB
 * -------------------------------------------------------------------- */

    p = alloca( 8192*2 ) ;

    if ( p == NULL )
    {
        printf( "X^bN̈悪mۂł܂\n" ) ;
        goto QUIT ;
    }

    proc01_pid = CreateThread( (char far *)test_proc01, p+2048, 2048 ) ;
    proc02_pid = CreateThread( (char far *)test_proc02, p+4096, 2048 ) ;
    
    printf( "Thread 1 Created pid = %d\n", proc01_pid ) ;
    printf( "Thread 2 Created pid = %d\n", proc02_pid ) ;

/* -------------------------------------------------------------------- *
   J[lJn
   }`^XNJnB
 * -------------------------------------------------------------------- */

    printf( "}`^XNJ[l̐Jn܂\n" ) ;

    kernel_start() ;

    printf( "}`^XNJ[l̐I܂\n" ) ;

/* -------------------------------------------------------------------- *
   Generic-16 J[l풓[`
   {vOɂăJ[lNĂ΁AJ[l̏풓
   B
 * -------------------------------------------------------------------- */
QUIT:
    if ( nstchk != FALSE )
    {
        printf( "Generic-16J[l̏풓܂\n" ) ;
        system( GEN16_KERNEL ) ;
    }
}

/*****************************************************************************
 * test_proc01 : eXgpvZXP                                          *
 *                                                                           *
 *****************************************************************************/

int test_proc01( void )
{
    int     mk ;

/* -------------------------------------------------------------------- *
   dispatch() PTCNr
   ̂`oh֐sƁAs𑼃vZXɏ邪ÃTCN
   ɖ߂ĂB
 * -------------------------------------------------------------------- */

    printf( "PROC-01 : vZXPJn܂\n" ) ;
    dispatch() ;

/* -------------------------------------------------------------------- *
   ipc_pinit, ipc_post, ipc_precvgpTv[`
   ipcV[Y֐̎gp@
 * -------------------------------------------------------------------- */

    /* IPCޯ̧Al͕֋XPgp */
    
    ipc_pinit( 1 ) ;                        

    /* ۾ł悤Ɏs       */

    dispatch() ;

    /* bZ[W͂܂ő҂ */
    
    mk=ipc_precv( 1, 0x000f, PRECV_WAIT ) ; 

    /* ꂽүނ 0x0F0FMүނ 0x000F ȂĂB     *
     * ͎MϽ 0x00FFw肵ĂׁBc 0x0F00 ̃bZ[W  *
     * ܂J[lɎcĂB                                        */

    printf( "PROC-01 : ү(%04X)\n", mk);

    /* x̓}XNׂăI[vɂĎMĂ݂B                     *
     * cĂ 0x0F00 ̃bZ[W󂯎                         */

    mk=ipc_precv( 1, 0xffff, PRECV_NOWAIT ) ; 
    printf( "PROC-01 : ү(%04X)\n", mk);

/* -------------------------------------------------------------------- *
   ^CXCXJn
   ^CXCXgp}`^XNs
 * -------------------------------------------------------------------- */

    printf( "^CXCXJn܂\n" ) ;

    TimeSlice( TMC_TMCLON ) ;

    sub_moddsp( "test_proc01 : ^CXCXs̃J[l" ) ;

/* -------------------------------------------------------------------- *
   vZX֐̃Tv[`
   ȍ~̓test_proc02琧󂯂
 * -------------------------------------------------------------------- */

	printf( "\n" ) ;

    while(1) {
        printf( "PROC-01 " ) ;
        sleep(10) ;
    }
}

/*****************************************************************************
 * test_proc02 : eXgpvZXQ                                          *
 *                                                                           *
 *****************************************************************************/

int test_proc02( void )
{
    int     nstate ;

/* -------------------------------------------------------------------- *
   sleep() vZXX[v
   ̂`oh֐sƁAs𑼃vZXɏ邪Aw肵
   vZX̐؂ւNƍĂюs\ƂȂBL̗łtest_proc01
   Qs邩A^CXCXɂs񐔂QɂȂ
   {vZXɐ䂪߂B
 * -------------------------------------------------------------------- */

    printf( "PROC-02 : vZXQJn܂\n" ) ;
    sleep(2) ;

/* -------------------------------------------------------------------- *
   Tv֐̎s
   J[lԁAуvZX\
 * -------------------------------------------------------------------- */

    sub_moddsp( "test_proc02 : J[l" ) ;
    sub_piddsp( "test_proc02 : vZX" ) ;

/* -------------------------------------------------------------------- *
   ipc_pinit, ipc_post, ipc_precvgpTv[`
   ipcV[Y֐̎gp@
 * -------------------------------------------------------------------- */

    ipc_pinit( 1 ) ;            /* ̷l test_proc01ɏ   */
                                /* Ă̂ŁA{޲ސ錾̂ */
    ipc_post ( 1, 0x0f0f ) ;    /* bZ[W 0x0F0F 𑗐M         */

/* -------------------------------------------------------------------- *
   vZX֐̃Tv[`
   test_proc01݂̌̏Ԃ\ 
 * -------------------------------------------------------------------- */

	sleep(100) ;

    nstate = getstate( proc01_pid ) ;

    printf( "\nPROC-01݂̌̏ = %X\n", nstate ) ;

/* -------------------------------------------------------------------- *
   vZX֐̃Tv[`
   test_proc01EGCgԂɂ
 * -------------------------------------------------------------------- */

	printf( "\nPROC-01~܂\n" ) ;

	setstate( proc01_pid, (nstate | 0x1000) ) ;

	sleep(15000) ;

/* -------------------------------------------------------------------- *
   vZX֐̃Tv[`
   test_proc01̓ĊJ
 * -------------------------------------------------------------------- */

	printf( "\nPROC-01̓ĊJ܂\n" ) ;

	setstate( proc01_pid, nstate ) ;

	sleep(10) ;

/* -------------------------------------------------------------------- *
   vZX֐̃Tv[`
   test_proc01B̊֐sƊYvZX͏
   ēx CreateThread֐ŏȂs邱Ƃ͂ȂB
 * -------------------------------------------------------------------- */

	printf( "\nPROC-01܂\n" ) ;

	kill( proc01_pid ) ;

/* -------------------------------------------------------------------- *
   J[lXgbv[`
   kernel_quit֐gpāAJ[l̓~
 * -------------------------------------------------------------------- */

    printf( "'e'L[ƃTvvOI܂\n" ) ;
    while( kbd_scan() ) ;

    while ( 1 )
    {
	    while(!kbd_scan() ) ;
		if ( kbd_input() == 'e' ) 
		{
			break ;
		}
	}
    kernel_quit() ;
}

/*****************************************************************************
 * sub_moddsp : J[l샂[h\֐                                   *
 * modeget()֐gpāAJ[l̓Ԃ\                     *
 *****************************************************************************/

int sub_moddsp( char *msg ) 
{
    struct _modgetbuf   modbuf ;
    char   *ptrno1, *ptrno2, *ptrno3 ;

/* -------------------------------------------------------------------- *
   modeget() J[l샂[h擾
   modeget֐̎gp
 * -------------------------------------------------------------------- */

    modeget( &modbuf ) ;

    ptrno1 = (modbuf.nmacid   == NMAC_PC9801) ? "PC_9801" : "IBM PC/AT"  ;
    ptrno2 = (modbuf.ntmslice ==  TMC_TMCLON) ? "ON"      : "OFF"        ;
    ptrno3 = (modbuf.nkernel  == KNL_IDLE   ) ? "Idle"    :
             (modbuf.nkernel  == KNL_ACTIVE ) ? "Active"  : "Exitting"   ;

    printf( ">>> %s <<<\n", msg ) ;
    printf( "@             : %s\n", ptrno1 ) ;
    printf( "ѽײL          : %s\n", ptrno2 ) ;
    printf( "ٓ         : %s\n", ptrno3 ) ;
    printf( "o^\ő۾  : %d\n", modbuf.nmaxtss   ) ;
    printf( "o^\őPOST   : %d\n", modbuf.nmaxpost  ) ;
    printf( "o^\őEXPORT : %d\n", modbuf.nmaxexp   ) ;
    printf( "o^\őϰ   : %d\n", modbuf.nmaxtimer ) ;
    printf( "o^\ő̫   : %d\n", modbuf.nmaxsemafo) ;

    return STS_NML ;
}

/*****************************************************************************
 * sub_piddsp : vZX샂[h\֐                                   *
 * getpinfo()֐gpāAvZX̓Ԃ\                    *
 *****************************************************************************/

int sub_piddsp( char *msg ) 
{
    struct _pinfo   pidbuf ;
    int    npid ;
    char   *ptrno1, *ptrno2, *ptrno3 ;

    printf( ">>> %s <<<\n", msg ) ;

/* -------------------------------------------------------------------- *
   getpid() vZXh擾
   getpid֐̎gp
 * -------------------------------------------------------------------- */

    npid = getpid() ;
    printf( "ΏۃvZX : %d\n", npid ) ;

/* -------------------------------------------------------------------- *
   getpinfo() vZX擾
   getpinfo֐̎gp
 * -------------------------------------------------------------------- */

    getpinfo( getpid(), &pidbuf ) ;

    printf( "۾     : %d\n",  pidbuf.nptyp  ) ;
    printf( "ڰѱڽ : %ld\n", pidbuf.nstack ) ;
    printf( "PID           : %d\n",  pidbuf.npid   ) ;
    printf( "PSP           : %X\n",  pidbuf.psp    ) ;
    printf( "DTA           : %ld\n", pidbuf.dta    ) ;

    return STS_NML ;
}

