/* ========================================================================== *
 *  Generic-16 Multi Task Kernel                                              *
 *  Sample program for Generic-16 API sample                                  *
 * ========================================================================== */

#include        <stdio.h>
#include        "gen16.h"
#include        "test02.h"

    int proc01_pid ;
    int proc02_pid ;

/*****************************************************************************
 * main : C[`                                                     *
 * TvvÕX^[g|Cg                                      *
 *****************************************************************************/

int main(int nargc, char *pargv[] )
{
    int     nidx, npid ;
    int     nstchk ;
    char   *p ;

/* -------------------------------------------------------------------- *
   
 * -------------------------------------------------------------------- */

    printf( "Generic Multi task kernel sample program No.002-A\n" ) ;

/* -------------------------------------------------------------------- *
   Generic-16 J[l풓胋[`
   J[l풓̏ꍇ풓čēx`FbNBRNɎs
   ꍇ́AG[bZ[W\ĈُIB܂AɃJ[l
   풓Ăꍇ̓tO(nstchk)ݒ肵Č듮hB
 * -------------------------------------------------------------------- */

    nstchk = FALSE ;

    for ( nidx=0; nidx<RETRY_MAX; nidx++ )
    {
        if ( _checkstay() )
        {   
            printf( "Generic-16 J[l풓܂\n" ) ;
            printf( "Kernel = %s\n", GEN16_KERNEL ) ;
            system( GEN16_KERNEL ) ;
            nstchk = TRUE ;
        } else {
            printf( "Generic-16 J[l̏풓mF܂\n" ) ;
            break ;
        }
    }
    if ( nidx == RETRY_MAX )
    {
        printf( "Generic-16 J[l풓ł܂ł\n" ) ;
        printf( "fBNg\`FbNċNȂĂ\n" ) ;
        exit(0);
    }

/* -------------------------------------------------------------------- *
   vZXo^[`
   vZX̃X^bN̈抄蓖ẮAK alloca֐gpĂB
 * -------------------------------------------------------------------- */

    p = alloca( 8192*2 ) ;

    if ( p == NULL )
    {
        printf( "X^bN̈悪mۂł܂\n" ) ;
        goto QUIT ;
    }

    proc01_pid = CreateThread( (char far *)test_proc01, p+2048, 2048 ) ;
    proc02_pid = CreateThread( (char far *)test_proc02, p+4096, 2048 ) ;
    
    printf( "Thread 1 Created pid = %d\n", proc01_pid ) ;
    printf( "Thread 2 Created pid = %d\n", proc02_pid ) ;

    printf( "eXgvOQN܂\n" ) ;

    system( "test02_B" ) ;

    printf( "eXgvOPI܂\n" ) ;

/* -------------------------------------------------------------------- *
   Generic-16 J[l풓[`
   {vOɂăJ[lNĂ΁AJ[l̏풓
   B
 * -------------------------------------------------------------------- */

QUIT:
    if ( nstchk != FALSE )
    {
        printf( "Generic-16J[l̏풓܂\n" ) ;
        system( GEN16_KERNEL ) ;
    }

}

/*****************************************************************************
 * test_proc01 : eXgpvZXP                                          *
 *                                                                           *
 *****************************************************************************/

int test_proc01( void )
{
    int     mk, nidx, nsts ;
    struct _tmgetinf timbuf ;
	struct teststr  far *tstptr ;
	
	int		(far *dllfunc)() ;

/* -------------------------------------------------------------------- *
   ^C}[̃Tv[`
   TimerSet, TimerGetу^C}`bNʒm̃Tv
 * -------------------------------------------------------------------- */

	printf( "TEST02_A: proc01: N܂\n" ) ;

    ipc_pinit( 1 ) ;
    ipc_pinit( 2 ) ;
    TimerSet ( 1, 10, 1, 1 ) ;

    for ( nidx=0; nidx<10; nidx++ )
    {
        mk = ipc_precv( 1, 0xffff, PRECV_WAIT ) ;
        printf( "TEST02_A: proc01: ^C}`bNM (%x)\n", mk ) ;
    }

    TimerGet( 1, &timbuf ) ;

	printf( "TEST02_A: proc01: ^C}[\\n" ) ;
    printf( "TEST02_A: proc01: M IPC_POSTL[   = %d\n", timbuf.nkyT ) ;
    printf( "TEST02_A: proc01: M IPC_POSTR[h = %d\n", timbuf.nCdT ) ;
    printf( "TEST02_A: proc01: ѱĒliۑpj    = %d\n", timbuf.norg ) ;
    printf( "TEST02_A: proc01: ϰl            = %d\n", timbuf.ncur ) ;

/* -------------------------------------------------------------------- *
   ^C}[̃Tv[`
   쐬^C}[
 * -------------------------------------------------------------------- */

	printf( "TEST02_A: proc01: ^C}[܂\n" ) ;
	KillTimer( 1 ) ;

/* -------------------------------------------------------------------- *
   _Ci~bNN֐̃Tv   
   TEST02_B.EXE  test_proc03() ɃbZ[W𑗐MăAhX
   exports킹
 * -------------------------------------------------------------------- */

	ipc_post( 2, 0x0100 ) ;

	dllfunc = import( 1 ) ;

	dllfunc( 10, "TEST02_A: proc01: This is test message" ) ;

/* -------------------------------------------------------------------- *
   _Ci~bNN֐̃Tv   
   TEST02_B.EXE  test_proc03() ɃbZ[W𑗐MăAhX
   exports킹 ̂Q
 * -------------------------------------------------------------------- */

	ipc_post( 2, 0x0200 ) ;

	tstptr = (struct teststr  far *)import( 2 ) ;

	printf( "TEST02_A: proc01: AhX import ܂\n" ) ;
	printf( "TEST02_A: proc01: tstptr.nidx1 = %d\n",  tstptr->nidx1 ) ;
	printf( "TEST02_A: proc01: tstptr.nidx2 = %d\n",  tstptr->nidx2 ) ;
	printf( "TEST02_A: proc01: tstptr.paddr1 = %s\n", tstptr->paddr1) ;
	printf( "TEST02_A: proc01: tstptr.paddr2 = %s\n", tstptr->paddr2) ;

/* -------------------------------------------------------------------- *
   _Ci~bNN֐̃Tv   
   TEST02_B.EXE  test_proc03() ɃbZ[W𑗐MăAhX
   export
 * -------------------------------------------------------------------- */

	ipc_post( 2, 0x0400 ) ;

	printf( "TEST02_A: proc01: Exort Key 1 = %x \n", import( 1 ) ) ;
	printf( "TEST02_A: proc01: Exort Key 2 = %x \n", import( 2 ) ) ;

/* -------------------------------------------------------------------- *
   Z}tH֐̃Tv   
   TEST02_B.EXE  test_proc03() ɃbZ[W𑗐MăZ}tH
@ 
 * -------------------------------------------------------------------- */

	ipc_semget( 1,      2 ) ;
	ipc_post  ( 2, 0x0010 ) ;

	nsts = ipc_semop ( 1, SEM_LOCK ) ;
	printf( "TEST02_A: proc01: Pڂ̃Z}tH sts = %d\n", nsts ) ;

	nsts = ipc_semop ( 1, SEM_LOAD ) ;
	printf( "TEST02_A: proc01: Z}tH = %d\n", nsts ) ;

	ipc_post  ( 2, 0x0020 ) ;
	ipc_post  ( 2, 0x0040 ) ;
	ipc_post  ( 2, 0x0020 ) ;

	printf( "TEST02_A: proc01: Z}tHJ܂\n" ) ;	
	nsts = ipc_semop ( 1, SEM_UNLOCK ) ;
	dispatch() ;

	nsts = ipc_semop ( 1, SEM_LOAD ) ;
	printf( "TEST02_A: proc01: Z}tH = %d\n", nsts ) ;

	printf( "TEST02_A: proc01: eXgI\n" ) ;

	ipc_post( 2, 0x1000 ) ;

	while (1)
	{
		sleep(10) ;
	}
}

/*****************************************************************************
 * test_proc02 : eXgpvZXQ                                          *
 *                                                                           *
 *****************************************************************************/

int test_proc02( void )
{

/* -------------------------------------------------------------------- *
   J[lXgbv[`
   kernel_quit֐gpāAJ[l̓~
 * -------------------------------------------------------------------- */

	printf( "TEST02_A: proc02: N܂\n" ) ;

	ipc_pinit( 2 ) ;
	ipc_precv( 2, 0xF000, PRECV_WAIT ) ;

	keywait( "TvvOI܂", 'e' ) ;

    kernel_quit() ;
}

/*****************************************************************************
 * keywait : L[͑҂֐                                                *
 *                                                                           *
 *****************************************************************************/

int keywait( char *msg, int wait )
{
  printf( "%s\n", msg ) ;

  if ( wait != 0 )
  {
  	printf( "'%c'L[Ă\n", wait ) ;
  } else {
    printf( "ǂꂩL[Ă\n" ) ;
  }

  while ( 1 )
  {
	while( kbd_scan() ) ;
	while(!kbd_scan() ) dispatch() ;
	
	if ( wait != 0 )
	{
	  if ( kbd_input() == wait )
	  {
	    break ;
	  }
	} else {
      break ;
	}
  }
  return STS_NML ;
}


