/* ========================================================================== *
 *  Generic-16 Multi Task Kernel                                              *
 *  Sample program for Generic-16 API sample                                  *
 * ========================================================================== */

#include        <stdio.h>
#include        "gen16.h"
#include        "test02.h"

    int proc01_pid ;
    int proc02_pid ;
	int test_procDL() ;

	struct teststr testbuf ;

/*****************************************************************************
 * main : C[`                                                     *
 * TvvÕX^[g|Cg                                      *
 *****************************************************************************/

int main(int nargc, char *pargv[] )
{
    int     nidx, npid ;
    int     nstchk ;
    char   *p ;

/* -------------------------------------------------------------------- *
   
 * -------------------------------------------------------------------- */

    printf( "Generic Multi task kernel sample program No.002-B\n" ) ;

/* -------------------------------------------------------------------- *
   Generic-16 J[l풓胋[`
   J[l풓̏ꍇ풓čēx`FbNBRNɎs
   ꍇ́AG[bZ[W\ĈُIB܂AɃJ[l
   풓Ăꍇ̓tO(nstchk)ݒ肵Č듮hB
 * -------------------------------------------------------------------- */

    nstchk = FALSE ;

    for ( nidx=0; nidx<RETRY_MAX; nidx++ )
    {
        if ( _checkstay() )
        {   
            printf( "Generic-16 J[l풓܂\n" ) ;
            printf( "Kernel = %s\n", GEN16_KERNEL ) ;
            system( GEN16_KERNEL ) ;
            nstchk = TRUE ;
        } else {
            printf( "Generic-16 J[l̏풓mF܂\n" ) ;
            break ;
        }
    }
    if ( nidx == RETRY_MAX )
    {
        printf( "Generic-16 J[l풓ł܂ł\n" ) ;
        printf( "fBNg\`FbNċNȂĂ\n" ) ;
        exit(0);
    }

/* -------------------------------------------------------------------- *
   vZXo^[`
   vZX̃X^bN̈抄蓖ẮAK alloca֐gpĂB
 * -------------------------------------------------------------------- */

    p = alloca( 8192*2 ) ;

    if ( p == NULL )
    {
        printf( "X^bN̈悪mۂł܂\n" ) ;
        goto QUIT ;
    }

    proc01_pid = CreateThread( (char far *)test_proc03, p+4096, 4096 ) ;
    proc02_pid = CreateThread( (char far *)test_proc04, p+8192, 4096 ) ;
    
    printf( "Thread 1 Created pid = %d\n", proc01_pid ) ;
    printf( "Thread 2 Created pid = %d\n", proc02_pid ) ;

/* -------------------------------------------------------------------- *
   J[lJn
   }`^XNJnB
 * -------------------------------------------------------------------- */

    printf( "}`^XNJ[l̐Jn܂\n" ) ;

    kernel_start() ;

    printf( "}`^XNJ[l̐I܂\n" ) ;


/* -------------------------------------------------------------------- *
   Generic-16 J[l풓[`
   {vOɂăJ[lNĂ΁AJ[l̏풓
   B
 * -------------------------------------------------------------------- */

QUIT:
    if ( nstchk != FALSE )
    {
        printf( "Generic-16J[l̏풓܂\n" ) ;
        system( GEN16_KERNEL ) ;
    }
}

/*****************************************************************************
 * test_proc03 : eXgpvZXP                                          *
 * 
 *****************************************************************************/

int test_proc03( void )
{
	int		mk ;

	printf( "TEST02_B: proc03: N܂\n" ) ;

	TimeSlice( 1 ) ;
	ipc_pinit( 1 ) ;
	ipc_pinit( 2 ) ;
	
	while ( 1 ) 
	{
		printf( "TEST02_B: proc03: bZ[WM EGCgJn\n" ) ;

		mk = ipc_precv( 2, 0x0F00, PRECV_WAIT ) ;

		printf( "TEST02_B: proc03: bZ[WM = %X\n", mk ) ;

		if ( mk & 0x0100 ) 
		{
			printf( "TEST02_B: proc03: _Ci~bNN֐o^܂\n" ) ;
			export( 1, (char far *)test_procDL ) ;
		}
		if ( mk & 0x0200 ) 
		{
			printf( "TEST02_B: proc03: ExportAhXo^܂\n" ) ;

			testbuf.nidx1  = 10 ;
			testbuf.nidx2  = 50 ;
			sprintf( testbuf.paddr1, "TEST BUF ̂P" ) ;
			sprintf( testbuf.paddr2, "test buf ̂Q" ) ;

			export( 2, (char far *)&testbuf ) ;
		}
		if ( mk & 0x0400 ) 
		{
			printf( "TEST02_B: proc03: ExportAhX܂\n" ) ;
			unexport( 1 ) ;			
			unexport( 2 ) ;
		}
	}
}

/*****************************************************************************
 * test_proc04 : eXgpvZXQ                                          *
 * 
 *****************************************************************************/

int test_proc04( void )
{
	int		nsts, mk ;

	printf( "TEST02_B: proc04: N܂\n" ) ;

	ipc_pinit( 2 ) ;

	while ( 1 ) 
	{
		printf( "TEST02_B: proc04: bZ[WM EGCgJn\n" ) ;

		mk = ipc_precv( 2, 0x00F0, PRECV_WAIT ) ;

		printf( "TEST02_B: proc04: bZ[WM = %X\n", mk ) ;

		if ( mk & 0x0010 )
		{
			printf( "TEST02_B: proc04: Z}tH̐ݒs܂\n" ) ;
			ipc_semget( 1, 2 ) ;
		}
		if ( mk & 0x0020 )
		{
			printf( "TEST02_B: proc04: Z}tH̑s܂\n" ) ;
			nsts = ipc_semop( 1, SEM_LOCK ) ;
			printf( "TEST02_B: proc04: Z}tH̑쌋 = %d\n", nsts ) ;
		}
		if ( mk & 0x0040 )
		{
			printf( "TEST02_B: proc04: NOWAIT̃Z}tH̑s܂\n" ) ;
			nsts = ipc_semop( 1, SEM_NWLOCK ) ;
			printf( "TEST02_B: proc04: Z}tH̑쌋 = %d\n", nsts ) ;
		}
	}
}

/*****************************************************************************
 * test_procDL : _Ci~bNNeXgp֐                        	     *
 * ̊֐́ATEST02_A.EXE test_proc01() Ăяo                 *
 *****************************************************************************/

int test_procDL( int nmsg, char far *msg )
{
	printf( "_Ci~bNN֐ test_procDL N܂\n" ) ;
    printf( "^ꂽp[^ nmsg=%d, msg=%s\n", nmsg, msg ) ;
}



