; ***********************************************************************
; *				GENERIC 16bit Realtime Task Monitor						*
; *	    Copyright 1991 - 1998 by Fritz Allrights Reserved.		        *
; *  -----------------------------------------------------------------  *
; *          Generic 16-bit Multi Task Kernel C[`            *
; *                                                                     *
; ***********************************************************************
;
				include	gen16.inc

; =====================================================================
;	J[lCf[^ZOg
; =====================================================================

gen16_data		segment	word public 'DATA' 
				assume  ds:gen16_data

	stay_msg	db		'GENERIC-16'
	my_psp		dw		?		; kernel PSP
	myds		dw 		?		; kernel DS
	reqvect		dd		?		; kernel Request INT Vector (OLD)
	mainstk		dd		?		; kernel quit address
	mainpsp		dw		?		; Kernel quit PSP
	maindta		dd		?		; kernel quit DTA
	timvect		dd		?		; Timer INT Vector			(OLD)
	nActive		dw		?		; Kernel STARTED = 1
	crnpid		dw		?		; Current PID
	crnpsp		dw		?		; Current PSP
	nReEntFlg	dw		?		; Timer Reentrant
	InDosFlg	dd		?		; In DOS Flag Address
	nTimeSlice	dw		?		; Time Slice Flag
	nSchedFlg   dw		?		; Sched Deadloop flag

	tcb			db		size TSS * MAX_TSS dup(?)
	lasttcb		label	byte

	msg_01		db		'Generic Realtime 16bit Task Monitor', 0dh, 0ah
				db		'Finished all kernel services.', 0DH, 0AH, '$', 0
	msg_02		db		'Generic Realtime 16bit Task Monitor', 0dh, 0ah
	            db      'Kernel activated. Generic System Ready.', 0dh, 0ah, '$', 0
    signdb		db		'Generic-16 Kernel 1997 by Fritz',0
gen16_data		ends

; =====================================================================
;	hob֘A̍ƃobt@
; =====================================================================

gen16ipc_data	segment	word public 'DATA' 
				assume  ds:gen16ipc_data
	
	genwrkstart label	byte

	ipc_postbuf	db		SIZE POSTTBL * MAX_POST   dup(?)
	exportDBbuf	db		SIZE EXPTTBL * MAX_EXPORT dup(?)
	timerTickDB	db		SIZE TIMERDB * MAX_TIMER  dup(?)
	ipc_semabuf db		SIZE SEMATBL * MAX_SEMAFO dup(?)
	
	genwrksize	dw		$ - genwrkstart

gen16ipc_data	ends

; =====================================================================
;	ү޷֘A̍ƃobt@
; =====================================================================

gen16msg_data	segment	word public 'DATA'

	ipc_msgbuf	label	byte
		msgctl	db		 3 * 1024 dup(?)
		msgbfd	db		60 * 1024 dup(?)
	ipc_msglen	dw		$ - ipc_msgbuf	

gen16msg_data	ends

; =====================================================================
;	ėpf[^֘A̍ƃobt@
; =====================================================================

gen16add_data	segment	word public 'DATA'

	opt_wrkbuf	label	byte
				db		1024 dup(?)
	opt_wrklen	dw		$ - opt_wrkbuf	

gen16add_data	ends

; =====================================================================
;	J[lR[hZOg
; =====================================================================

gen16_code		segment	byte public 'CODE'
				assume  cs:gen16_code, ds:gen16_data, ss:stack

				public	START
				public	SSTV

; =======================================================================
;	proc_01 = Generic Kernel System Ivtٰ
;	Generic KernelLĂApsp̱ڽԂ
; =======================================================================

	proc_01		proc	far
				push	ds
				push	dx
				push	cx
				mov		ax, gen16_data
				mov		ds, ax
				;
				;	ظ޸ɖ߂
				;
				push	ds
				mov		dx, word ptr ds:[reqvect + 0]
				mov		ax, word ptr ds:[reqvect + 2]
				mov		ds, ax
				mov		ah, 25h
				mov		al, VECT_NO
				int		21h
				pop		ds
				;
				;	ϰ荞޸ɖ߂
				;
		if PC_9801
				nop
				mov		cx, 0ffffh
				mov		word ptr ds:[nActive], 2
			p1A:mov		ax, word ptr ds:[nActive]
				or		ax, ax
				jz		p2A
				loop	p1A
			p2A:
		else
				push	ds
				mov		dx, word ptr ds:[timvect + 0]
				mov		ax, word ptr ds:[timvect + 2]
				mov		ds, ax
				mov		ah, 25h
				mov		al, VECT_TM
				int		21h
				pop		ds
		endif
				;
				;	قpsp̃AhX
				;
				mov		bx, word ptr ds:[my_psp]
				;
				pop		cx
				pop		dx
				pop		ds
				ret
	proc_01		endp

	include		kernel.asm

; =======================================================================
;	stay_proc = ظĎtٰ
;	ĳ荞݂ɂ鶰ظĂ󂯕t
; =======================================================================

	stay_mark	db		'GENERIC-16'

	stay_proc	proc	far
		stay_0:	cmp		ah, QUIT_REQ
				jnz		stay_1
				call	proc_01
				jmp		stay_q
		stay_1:	cmp		ah, THREAD_REQ
				jnz		stay_2
				call	proc_02
				jmp		stay_q
		stay_2: cmp		ah, DISPATCH_REQ
				jnz		stay_3
				call	proc_03
				jmp		stay_q
		stay_3: cmp		ah, GETPID_REQ
				jnz		stay_4
				call	proc_04
				jmp		stay_q
		stay_4: cmp		ah, START_REQ
				jnz		stay_5
				call	proc_05
				jmp		stay_q
		stay_5: cmp		ah, KQUIT_REQ
				jnz		stay_6
				call	proc_06
				jmp		stay_q
		stay_6: cmp		ah, GETSTS_REQ
				jnz		stay_7
				call	proc_07
				jmp		stay_q
		stay_7: cmp		ah, SETSTS_REQ
				jnz		stay_8
				call	proc_08
				jmp		stay_q
		stay_8: cmp		ah, IPCPINIT_REQ
				jnz		stay_9
				call	proc_09
				jmp		stay_q
		stay_9: cmp		ah, IPCPOST_REQ
				jnz		stay10
				call	proc_10
				jmp		stay_q
		stay10:	cmp		ah, IPCPRECV_REQ
				jnz		stay11
				call	proc_11
				jmp		stay_q
		stay11:	cmp		ah, KILL_REQ
				jnz		stay12
				call	proc_12
				jmp		stay_q
		stay12:	cmp		ah, EXPORT_REQ
				jnz		stay13
				call	proc_13
				jmp		stay_q
		stay13:	cmp		ah, IMPORT_REQ
				jnz		stay14
				call	proc_14
				jmp		stay_q
		stay14:	cmp		ah, UNEXPORT_REQ
				jnz		stay15
				call	proc_15
				jmp		stay_q
		stay15:	cmp		ah, SETTIMER_REQ
				jnz		stay16
				call	proc_16
				jmp		stay_q
		stay16:	cmp		ah, GETTIMER_REQ
				jnz		stay17
				call	proc_17
				jmp		stay_q
		stay17:	cmp		ah, SEMGET_REQ
				jnz		stay18
				call	proc_18
				jmp		stay_q
		stay18:	cmp		ah, SEMOPE_REQ
				jnz		stay19
				call	proc_19
				jmp		stay_q
		stay19:	cmp		ah, SLEEP_REQ
				jnz		stay20
				call	proc_20
				jmp		stay_q
		stay20:	cmp		ah, MODGET_REQ
				jnz		stay21
				call	proc_21
				jmp		stay_q
		stay21:	cmp		ah, TMSLICE_REQ
				jnz		stay22
				call	proc_22
				jmp		stay_q
		stay22:	cmp		ah, GETPINF_REQ
				jnz		stay23
				call	proc_23
				jmp		stay_q
		stay23: cmp     ah, KILLT_REQ
		        jnz     stay24
		        call    proc_24
		        jmp     stay_q
		stay24: cmp		ah, MSGGET_REQ
				jnz		stay25
				call	proc_25
				jmp		stay_q
		stay25:	cmp		ah, MSGSND_REQ
				jnz		stay26
				call	proc_26
				jmp		stay_q
		stay26:	cmp		ah, MSGRCV_REQ
				jnz		stay27
				call	proc_27
				jmp		stay_q
		stay27:	cmp		ah, ADDON_REQ
				jnz		stay28
				call	proc_28
				jmp		stay_q
		stay28: cmp		ah, ADDOFF_REQ
				jnz		stay29
				call	proc_29
				jmp		stay_q
		stay29: cmp		ah, ADDGET_REQ
				jnz		stay30
				call	proc_30
				jmp		stay_q
		stay30: 
		stay31:
		stay_q:
				iret
	stay_proc	endp

; =======================================================================
;	check_stay = 풓ٰ
;	Generic Kernel тɏ풓Ăꍇ͏풓
;	풓ĂȂꍇ͏풓
; =======================================================================

	check_stay	proc	far
				;
				;	قɏ풓Ă邩肷
				;
				mov		ah, 35h
				mov		al, VECT_NO
				int		21h
				mov		di, bx
				sub		di, 10
				mov  	si, offset stay_msg
				cld
				xor		ax, ax
				mov		cx, 10
				repz	cmpsb
				jnz		stay_new
				;
				;	ɏ풓Ăꍇ풓
				;
				mov		ax, gen16_data
				mov		es, ax
				mov		ds, ax
				mov		dx, offset msg_01
				mov		ah, 9
				int		21h
				mov		ah, QUIT_REQ
				int		VECT_NO
				mov		es, bx
				push	es
				mov		ax, word ptr es:[2ch]
				mov		es, ax
				mov		ah, 49h
				int		21h
				pop		es				
				mov		ah, 49h
				int		21h
				mov		ah, 4ch
				int		21h
				;
				;	풓Jn
				;
	stay_new:	mov		dx, offset msg_02
				mov		ah, 9
				int		21h
				;
				;	ظ޸ۑ
				;
				mov		ah, 35h
				mov		al, VECT_NO
				int		21h
				mov		word ptr ds:[reqvect + 0], bx
				mov		word ptr ds:[reqvect + 2], es
				;
				;	ظٰ݂o^
				;
				push	ds
				push	cs
				pop		ds
				mov		ah, 25h
				mov		al, VECT_NO
				mov		dx, offset stay_proc
				int		21h
				pop		ds

		if PC_9801
				push	bx
				push	cx
				push	es
				mov		cx, 5		; 5 * 10 ms.
				mov		ax, cs
				mov		es, ax
				mov		bx, offset TimerINTproc
				mov		ah, 2
				int		1ch
				pop		es
				pop		cx
				pop		bx
				nop
		else
				;
				;	ϰ荞޸ۑ
				;
				mov		ah, 35h
				mov		al, VECT_TM
				int		21h
				mov		word ptr ds:[timvect + 0], bx
				mov		word ptr ds:[timvect + 2], es
				;
				;	ϰ荞ٰ݂o^
				;
				push	ds
				push	cs
				pop		ds
				mov		ah, 25h
				mov		al, VECT_TM
				mov		dx, offset TimerINTproc
				int		21h
				pop		ds
		endif
				;
				;	풓
				;	
	SSTV:
				.386p
				xor		eax, eax
				mov		ax, stack
				mov		cl, 4
				shl		eax, cl
				add		eax, offset gen16_stack
				;
				xor		ebx, ebx
				mov		bx, gen16_data
				mov		cl, 4
				shl		ebx, cl
				add		ebx, offset stay_msg
				sub		eax, ebx
				shr		eax, 4
				.8086
				mov		dx, ax
				inc		dx
				;
				mov		ax, 3100h
				int		21h
				
	check_stay	endp

; =======================================================================
;	START = Generic Kernel C[`
; =======================================================================

	START		proc	far
				;
				;	Generic 16-bit ُJn
				;
				mov		ax, gen16_data
				mov		ds, ax
				pushf
				cli
				mov		ax, stack
				mov		ss, ax
				mov		sp, offset gen16_stack
				popf
				;
				;	قPSP̱ڽۑ
				;
				mov		ah, 62h
				int		21h
				mov		word ptr ds:[my_psp], bx
				;
				;	ق̍Ɨ̈
				;
				mov		ax, gen16_data
				mov		es, ax
				mov		di, offset tcb
				mov		cx, size TSS * MAX_TSS
				xor		al, al
				cld
				rep		stosb
				mov		word ptr ds:[crnpid ], offset tcb
				mov		word ptr ds:[crnpsp ], 0
				mov		word ptr ds:[nActive], 0
				;
				;	In DOS Flag擾
				;
				mov		ah, 34h
				int		21h
				dec		bx
				mov		word ptr ds:[InDosFlg+0], bx
				mov		word ptr ds:[InDosFlg+2], es
				;
				;	ُ풓菈
				;
				call 	check_stay
	START		endp

gen16_code		ends

; =====================================================================
;	J[lX^bNZOg
; =====================================================================

stack			segment	stack para 'STACK'
				assume	ss:stack

				db		1024 * 4 dup(?)
	gen16_stack label	byte

stack			ends
				end		START
