/***********************************************************************
 *				GENERIC 16bit Realtime Task Monitor					   *
 *	    Copyright 1991 - 1998 by Fritz Allrights Reserved. 	           *
 *  -----------------------------------------------------------------  *
 *                   IBM PC/ATpėpTu[`W                     *
 *                                                                     *
 ***********************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<dos.h>
#include	"scr16ibm.h"

/* ======================================================================== *
   ------------------------------------------------------------------------
 * ======================================================================== */

/* ======================================================================== *
   INKEY = L[{[h
   ------------------------------------------------------------------------
   unsigned int inkey( void )

   Sp␧L[̓͂\ȃL[̓[`BL[ƂĂ͈ȉ
   L[t\B
	INS,	DEL,	HOME,	END,	PGUP,	PGDN,	 UP,	DOWN,
	RIGHT,	LEFT,	BS,		TAB,	STAB,	ENTER,	ESC,
	F1,		F2,		F3,		F4,		F5,		F6,		F7,		F8,
	F9,		F10,	SF1,	SF2,	SF3,	SF4,	SF5,	SF6,
	SF7,	SF8,	SF9,	SF10,
 * ======================================================================== */

unsigned inkey(void)
{
	_asm {
		mov		ah, 01h			//	check keyboard buffer
		int		0x16
		jz		Nothing

		mov		ah, 00h			//	read next character
		int		0x16			//	AH	=	scan code
								//	AL	=	ASCII character code
		or		al, al
		jz		Exit			//	special characters such as function keys
		cmp		al, 80h
		jc		Ascii
		cmp		al, 0a0h
		jc		Kanji
		cmp		al, 0e0h
		jc		Ascii			//	katakana
Kanji:	push	ax
		mov		ah, 00h
		int		0x16
		pop		dx
		mov		ah, dl
		jmp		short Exit
Ascii:	xor		ah, ah
		jmp		short Exit
Nothing:xor		ax, ax
Exit:
	}
}

/* ======================================================================== *
   PUTKT = ᐅ\
   ------------------------------------------------------------------------
   void putkt(char *dat, int len, int atr, int x, int y)
   		( IN) dat \
   		( IN) len 
   		( IN) atr \F
   		( IN) x   \ʒuw
   		( IN) y@ \ʒux
   ʂ̔Cӂ̕Wɕ\BGXP[vV[PX͕sB
 * ======================================================================== */

void putkt(char *dat, int len, int atr, int x, int y)
{
	_asm {
		push	bp
		mov		cx, len				//	Get length of data
		mov		ax, y				//	Get y_position
		mov		dx, x				//	Get x_position
		mov		dh, al				//	Set xy_position
		mov		bx, atr				//	Get attribute
		mov		bh, 0				//	Set page 0
		les		di, dword ptr dat	//	Get data address
		mov		bp, di
		mov		al, 0
		mov		ah, 13h
		int		10h					//	Call putstr
		pop		bp
	}
}

/* ======================================================================== *
   PutPort = |[gݏ
   ------------------------------------------------------------------------
   void PutPort( int nport, int ndata )
   		( IN) nport |[gԍ
   		( IN) ndata ݃f[^
   nport Ŏw肳ꂽ I/O |[g ndata Ŏw肳ꂽPoCgf[^
   
 * ======================================================================== */

void PutPort( int nport, int ndata )
{
	unsigned char	bdata, bport ;
	
	bdata = (unsigned char)ndata ;

	_asm{
		push	dx
		mov		al, bdata
		mov		dx, nport
		out     dx, al
		pop		dx
	}
}

/* ======================================================================== *
   GetPort = |[gǂݏo
   ------------------------------------------------------------------------
   int GetPort( int nport )
   		( IN) nport |[gԍ
   nport Ŏw肳ꂽ I/O|[gf[^ǂ݂
 * ======================================================================== */

int GetPort( int nport )
{
	int		ndta ;
	
	_asm{
		push	dx
		xor		ax, ax
		mov		dx, nport
		in		al, dx
		mov	  ndta, ax
		pop		dx
	}
	return ndta ;
}

/* ======================================================================== *
   MicroDelay = sx
   ------------------------------------------------------------------------
   void MicroDelay( long ndelay )
   		( IN) ndelay x
   BIOSgpăvO̎sԂxBndelayɎw肷l
   0x200000.5bɂȂB
 * ======================================================================== */

void MicroDelay( long ndelay )
{
	 union REGS ourregs;
	 unsigned int  sx1, sx2 ;
	 
	 sx1 = (int)ndelay ;
	 sx2 = (int)((ndelay>>16) & 0x0000ffff) ;

	ourregs.h.ah = 0x86;
	ourregs.x.cx = sx2;
	ourregs.x.dx = sx1;
	int86(0x15, &ourregs, &ourregs);  
}

/* ======================================================================== *
   sound = Xs[J炷
   ------------------------------------------------------------------------
   int sound( int herz, int length )
       ( IN) herz   g
       ( IN) length Xs[J炷
 * ======================================================================== */

int sound( int herz, int length )
{
	unsigned int	ndata ;
	unsigned long	nbase ;

	ndata = 1190 / herz ;
	nbase = 0x20000 * length ;
	
	PutPort( 0x43, 0xB6 ) ;
	PutPort( 0x42, ndata) ;
	PutPort( 0x42,    0 ) ;
    PutPort( 0x61, (GetPort(0x61) | 0x03)) ;
	MicroDelay( nbase ) ;
    PutPort( 0x61, (GetPort(0x61) & 0xFC));
}

/* ======================================================================== *
   ------------------------------------------------------------------------
 * ======================================================================== */

int EditLine( char *dta, char *frmt, char *rslt, int x, int y )
{
  int   nidx ;
  int   cur_posx, cur_posy, cur_loct, kbd_data, str_limt, chr_rule ;
  char  edt_line[ 256 ] ;

  while( inkey() ) ;

  cur_posx = x ;
  cur_posy = y ;
  cur_loct = 0 ;
  str_limt = ReadLimit( frmt ) ;

  strcpy( edt_line, dta ) ;  
  putkt ( dta, strlen(dta), 0x07, x, y ) ;

  for( nidx=0; nidx<str_limt; nidx++, cur_loct++ )
  {
    if ( CheckRule( 0, frmt, nidx ) != RTN_LOC )
    {
      break ;
    }
  }
  if ( nidx == str_limt )
  {
    return -1 ;
  }

  while ( 1 )
  {
    putkt( &edt_line[cur_loct], 1, 0x20, cur_posx+cur_loct, cur_posy ) ;

    while( !(kbd_data = inkey()) ) ;

RETRY:
    putkt( &edt_line[cur_loct], 1, 7, cur_posx+cur_loct, cur_posy ) ;

    switch( kbd_data )
    {
    case ENTER:
      strcpy( rslt, edt_line ) ;
      return 0 ;
    case UP:
      strcpy( rslt, edt_line ) ;
      return UP ;
    case DOWN:
      strcpy( rslt, edt_line ) ;
      return DOWN ;
    case RIGHT:
      if ( cur_loct < str_limt-1 ) 
      {
        cur_loct = cur_loct + 1 ;      
      }
	  if ( CheckRule( kbd_data, frmt, cur_loct ) == RTN_LOC )
	  {
	    kbd_data = ( cur_loct == str_limt-1 ) ? LEFT : RIGHT ;
	    goto RETRY ;
	  }
      break ;
    case LEFT:
      if ( cur_loct > 0 )
      {
        cur_loct = cur_loct - 1 ;
      }
	  if ( CheckRule( kbd_data, frmt, cur_loct ) == RTN_LOC )
	  {
	    kbd_data = ( cur_loct == 0 ) ? RIGHT : LEFT ;
	    goto RETRY ;
	  }
      break ;
    case ESC:
      return -1 ;
    default:
      if ( (chr_rule = CheckRule( kbd_data, frmt, cur_loct )) < 0 )
      {
        break ;
      }
      if ( chr_rule == 1 )
      {
        edt_line[cur_loct] = '*' ;
      } else {
        edt_line[cur_loct] = kbd_data ;
      }
      kbd_data = RIGHT ;
      goto RETRY ;
    }
  }
}

static char chktbl[] = {
 /*          +0   +1   +2   +3   +4   +5   +6   +7   +8   +9   +A   +B   +C   +D   +E   +F */
 /* +00 */ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 /* +01 */ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 /* +02 */ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 /* +03 */ 0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x08,0x08,0x08,0x08,0x08,0x08,
 /* +04 */ 0x08,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,
 /* +05 */ 0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x08,0x08,0x08,0x08,0x08,
 /* +06 */ 0x08,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,
 /* +07 */ 0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x08,0x08,0x08,0x08,0x08,
 /* +08 */ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 /* +09 */ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 /* +0A */ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 /* +0B */ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 /* +0C */ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 /* +0D */ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 /* +0E */ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 /* +0F */ 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00} ;
 /*
   0x01 = Digit,   0x02 = Big Alpha,   0x04 = Small Alpha, 0x08 = Symbol
   
           30(0),31(1),32(2),33(3),34(4),35(5),36(6),37(7),38(8),
           39(9),3A(:),3B(;),3C(<),3D(=),3E(>),3F(?),40(@),41(A),
           42(B),43(C),44(D),45(E),46(F),47(G),48(H),49(I),4A(J),
           4B(K),4C(L),4D(M),4E(N),4F(O),50(P),51(Q),52(R),53(S),
           54(T),55(U),56(V),57(W),58(X),59(Y),5A(Z),5B([),5C(\),
           5D(]),5E(^),5F(_),60(`),61(a),62(b),63(c),64(d),65(e),
           66(f),67(g),68(h),69(i),6A(j),6B(k),6C(l),6D(m),6E(n),
           6F(o),70(p),71(q),72(r),73(s),74(t),75(u),76(v),77(w),
           78(x),79(y),7A(z),7B({),7C(|),7D(}),7E(~),7F(),
 */

/* ======================================================================== *
   ------------------------------------------------------------------------
 * ======================================================================== */

static int CheckRule( int data, char *frmt, int pos )
{
	int      nchr, nidx, nflg, idbg ;
	char	*ptr, *ptv ;
	char	 tmpbuf[32] ;

	nidx = 0 ;
	for ( ptr=frmt; *ptr; ptr++, nidx++ )
	{
      if ( *ptr == '$' || *ptr == '%' )
      {
        nflg =  (*ptr == '$') ? RTN_NML : RTN_PAS ;
		ptr++ ;
		if ( *ptr == 0 ) 
		{
		  return -1 ;
		}
		if ( *ptr == '%' && nflg==RTN_PAS && nidx==pos )
		{
		  return RTN_LOC ;
		}
		if ( *ptr == '$' && nflg==RTN_NML && nidx==pos )
		{
		  return RTN_LOC ;
		}
		  
		if ( *ptr == 'D' && nidx==pos )
		{
		  if ( chktbl[ data ] & 0x01 )
		  {
            return nflg ;
		  }
		} 
		if ( *ptr == 'A' && nidx==pos )
		{
		  if ( chktbl[ data ] & 0x06 )
		  {
            return nflg ;
		  }
		} 
		if ( *ptr == 'S' && nidx==pos )
		{
		  if ( chktbl[ data ] & 0x08 )
		  {
            return nflg ;
		  }
		} 
		if ( isdigit(*ptr) )
		{
		  memset( tmpbuf, 0, sizeof(tmpbuf) ) ;
		  for( ptv=tmpbuf; *ptr && isdigit(*ptr); *ptv++ = *ptr++ ) ;
          if ( *ptr == 0 )
          {
            return -1 ;
          }
          nchr = atoi( tmpbuf ) ;
          for( ; *ptr && nchr; ptr++, nchr-- ) 
          {
            if ( nidx == pos )
            {
              if ( *ptr == data )
              {
                return nflg ;
              }
            }
          }
          if ( *ptr == 0 )
          {
            return -1 ;
          }
          ptr-- ;
        }	  
	  } else {
        if ( nidx == pos )
        {
        	return RTN_LOC ;
	    }
	  }
    }
	return -1 ;
}

/* ======================================================================== *
   ------------------------------------------------------------------------
 * ======================================================================== */

static int ReadLimit( char *frmt ) 
{
	int      nchr, nidx ;
	char	*ptr, *ptv ;
	char	 tmpbuf[32] ;

    nidx = 0 ;

	for ( ptr=frmt; *ptr; ptr++ )
	{
	  nidx++ ;
      if ( *ptr == '$' || *ptr == '%' )
      {
		ptr++ ;
		if ( *ptr == 0 ) 
		{
		  return -1 ;
		}
		if ( isdigit(*ptr) )
		{
		  memset( tmpbuf, 0, sizeof(tmpbuf) ) ;
		  for( ptv=tmpbuf; *ptr && isdigit(*ptr); *ptv++ = *ptr++ ) ;
          if ( *ptr == 0 )
          {
            return -1 ;
          }
          nchr = atoi( tmpbuf ) ;
          for( ; *ptr && nchr; ptr++, nchr-- ) ;
          if ( *ptr == 0 )
          {
            return -1 ;
          }
        }	  
	  }
    }
	return nidx ;
}


  

